import { Temperature } from './setters.js';

describe('the `Temperature` class', () => {
  test('has a `celsius` field and no others', () => {
    const temperature = new Temperature(20);
    expect(Object.getOwnPropertyNames(temperature).sort()).toEqual(['celsius']);
  });
  test('stores the Celsius temperature given at construction time', () => {
    const temperature = new Temperature(20);
    expect(temperature.celsius).toBe(20);
  });
  test('provides a getter for the equivalent Fahrenheit temperature', () => {
    const temperature = new Temperature(20);
    expect(temperature.fahrenheit).toBe(68);
  });
  test('supports modifications by setting an object\'s `celsius` field', () => {
    const temperature = new Temperature(20);
    temperature.celsius = 15;
    expect(temperature.celsius).toBe(15);
    expect(temperature.fahrenheit).toBe(59);
  });
  test('supports modifications via a `fahrenheit` setter', () => {
    const temperature = new Temperature(20);
    temperature.fahrenheit = 59;
    expect(Object.getOwnPropertyNames(temperature).sort()).toEqual(['celsius']);
    expect(temperature.celsius).toBe(15);
    expect(temperature.fahrenheit).toBe(59);
  });
});
