import { PlanarVector } from './methods.js';

describe('the first `PlanarVector` class', () => {
  test('correctly computes dot products between parallel vectors', () => {
    const u = new PlanarVector(1, 4);
    const v = new PlanarVector(-2, -8);
    expect(u.dotProduct(v)).toBe(-34);
  });
  test('correctly computes dot products between orthogonal vectors', () => {
    const u = new PlanarVector(1, 4);
    const v = new PlanarVector(8, -2);
    expect(u.dotProduct(v)).toBe(0);
  });
  test('correctly computes dot products between vectors at an angle', () => {
    const u = new PlanarVector(1, 4);
    const v = new PlanarVector(5, 9);
    expect(u.dotProduct(v)).toBe(41);
  });
});
