import { Accumulator } from './spreadOperator.js';

describe('the `Accumulator` class', () => {
  test('starts out empty', () => {
    const accumulator = new Accumulator();
    expect(accumulator.content).toEqual([]);
  });
  test('can accumulate one element at a time', () => {
    const accumulator = new Accumulator();
    accumulator.addAll(['foo']);
    accumulator.addAll(['bar']);
    expect(accumulator.content).toEqual(['foo', 'bar']);
  });
  test('can accumulate several elements at once', () => {
    const accumulator = new Accumulator();
    accumulator.addAll(['foo', 'bar', 'baz']);
    expect(accumulator.content).toEqual(['foo', 'bar', 'baz']);
  });
});
