import { makeBetweenFilter } from './arrowFunctions.js';

describe('the `makeBetweenFilter` function', () => {
  test('makes a filter that rejects numbers that are below the lower bound', () => {
    const filter = makeBetweenFilter(0, 10);
    expect(filter(-1)).toBe(false);
  });
  test('makes a filter that accepts numbers that are the lower bound', () => {
    const filter = makeBetweenFilter(0, 10);
    expect(filter(0)).toBe(true);
  });
  test('makes a filter that accepts numbers that are between the bounds', () => {
    const filter = makeBetweenFilter(0, 10);
    expect(filter(1)).toBe(true);
    expect(filter(9)).toBe(true);
  });
  test('makes a filter that rejects numbers that are the upper bound', () => {
    const filter = makeBetweenFilter(0, 10);
    expect(filter(10)).toBe(false);
  });
  test('makes a filter that rejects numbers that are above the upper bound', () => {
    const filter = makeBetweenFilter(0, 10);
    expect(filter(11)).toBe(false);
  });
});
